--[[
 TA Tails (Tails Adventure Tails)
	by WhisperVII (with some help from SRB2 discord)
		Mlem :3
	This is my first ACTUAL character (not counting the edits I did to CDSonic and I've never touched Lua outside of him so
	I can guarantee this code is not optimized in the slightest. 
]]--

//Emote Stuff
freeslot("SPR2_TASP", "S_TAILSPIN", "S_UPSIDE", "SPR2_TUPD", "SPR2_TDNC", "S_TPIPE")
states[S_TAILSPIN] = {SPR_PLAY, SPR2_TASP, 3, nil, 0, 0, S_TAILSPIN}
states[S_UPSIDE] = {SPR_PLAY, SPR2_TUPD, 4, nil, 0, 0, S_UPSIDE}
states[S_TPIPE] = {SPR_PLAY, SPR2_TDNC, 3, nil, 0, 0, S_TPIPE}

//Victory Animation Stuff
freeslot("S_TVICTORY1","S_TVICTORY2", "SPR_MIVC", "SPR2_TAVC")
states[S_TVICTORY1] = {
	sprite = SPR_MIVC,
	frame = FF_ANIMATE|A,
	tics = 57,
	var1 = 19,
	var2 = 3,
	nextstate = S_TVICTORY2
}

states[S_TVICTORY2] = {
	sprite = SPR_MIVC,
	frame = T,
	tics = 1,
	nextstate = S_TVICTORY2
}

//Powerup Obtained Things
/*freeslot("S_TAILS_PICKUP", "S_TAILS_PICKUP2", "S_TAILS_PICKUP3", "SPR2_OBTN", "SPR2_OBTM")
states[S_TAILS_PICKUP] = {
	sprite = SPR_PLAY,
	frame = SPR2_OBTN|FF_ANIMATE|A,
	tics = 24,
	var1 = 2,
	var2 = 8,
	nextstate = S_TAILS_PICKUP2
}*
states[S_TAILS_PICKUP2] = {
	sprite = SPR_PLAY,
	frame = SPR2_OBTM|A,
	tics = 24,
	var1 = 0,
	var2 = 1,
	nextstate = S_TAILS_PICKUP3
}
states[S_TAILS_PICKUP3] = {
	sprite = SPR_PLAY,
	frame = SPR2_OBTM|FF_ANIMATE|B,
	tics = 16,
	var1 = 1,
	var2 = 8,
	nextstate = S_PLAY_STND
}*/

//Helmet Things
freeslot("S_HELM", "S_HELMB", "SPR_HELM")
states[S_HELM] = {
	sprite = SPR_HELM,
	frame = FF_ANIMATE|A,
	tics = 10,
	var1 = 1,
	var2 = 5,
	nextstate = S_HELMB
}
states[S_HELMB] = {
	sprite = SPR_HELM,
	frame = FF_ANIMATE|C,
	tics = 70,
	var1 = 0,
	var2 = 70,
	nextstate = S_PLAY_STND
}

//Bomb Throw Things
freeslot("S_BTHROW", "SPR_TABB")
states[S_BTHROW] = {
	sprite = SPR_TABB,
	frame = FF_ANIMATE|A,
	tics = 8,
	var1 = 3,
	var2 = 2,
	nextstate = S_PLAY_STND
}

//Menuing
freeslot("S_TAILS_MENU", "SPR2_TAMU")
states[S_TAILS_MENU] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAMU,
	tics = 18,
	var1 = 2,
	var2 = 6,
	nextstate = S_TAILS_MENU
}

//Tails S2 Waiting Stuff
/*freeslot("S_TAILS_WAIT", "S_TAILS_WAIT2", "SPR_TWAI")
states[S_TAILS_WAIT] = {
	sprite = ,
	frame = FF_ANIMATE|A,
	tics = 3,
	var1 = 0,
	var2 = 3,
	nextstate = S_TAILS_WAIT2
}
states[S_TAILS_WAIT2] = {
	sprite = ,
	frame = FF_ANIMATE|A,
	tics = ,
	var1 = ,
	var2 = ,
	nextstate = S_TAILS_WAIT2
}*/

//Set Up Variables
addHook("PlayerThink", function(player)
	local mo = player.mo
	local skin = "tatails"
	
	if not (mo or mo.valid
	or mo.skin ~= skin)
		return
	end
	
	if not player.tailssetup
		player.tpipebomb = false
		player.upside = false
		player.tailsrun = false
		player.tailshelmet = false
		player.tailsnapalm = false
		player.tailsraido = false
		player.tailsrobot = false
		player.tailsroboting = false
		player.tailsmenuing = false
		player.tailsselect = 1
		player.tailssetup = true
	end
end)

//HUD Stuff
hud.add(function(v, player)
	local mo = player.mo
	local skin = "tatails"
	
	if not (mo or mo.valid
	or mo.skin ~= skin)
	and not G_IsSpecialStage()
		return
	end
	
	if mo.skin == skin
		local mlem
		if player.tailsselect == 2
			mlem = "PWNP"
		elseif player.tailsselect == 3
			mlem = "PWHM"
		elseif player.tailsselect == 4
			mlem = "PWRN"
		elseif player.tailsselect == 5
			mlem = "PWRB"
		elseif player.tailsselect == 6
			mlem = "PWRD"
		else
			mlem = "PWBB"
		end
	
		if player.tailsmenuing
			local fpp = V_PERPLAYER|V_HUDTRANS
			v.drawString(270, 60, "Press Jump to select", fpp|V_YELLOWMAP, "thin-center")
			v.drawString(270, 70, "Press Spin to cancel", fpp|V_YELLOWMAP, "thin-center")
			v.drawScaled(100*FRACUNIT, 20*FRACUNIT, FRACUNIT/1, v.cachePatch("TAMENU"), V_HUDTRANS|V_PERPLAYER)
			local pow1 = v.cachePatch("BOMB")
			local pow2 = v.cachePatch("???")
			if player.tailsnapalm
				pow2 = v.cachePatch("NAPALM")
			end
			local pow3 = v.cachePatch("???")
			if player.tailshelmet
				pow3 = v.cachePatch("HELMET")
			end
			local pow4 = v.cachePatch("???")
			if player.tailsrun
				pow4 = v.cachePatch("SHOES")
			end
			local pow5 = v.cachePatch("???")
			if player.tailsrobot
				pow5 = v.cachePatch("ROBOT")
			end
			local pow6 = v.cachePatch("???")
			if player.tailsraido
				pow6 = v.cachePatch("RAIDO")
			end
			local box = v.cachePatch("BOX")
			if player.powitem == 0
				v.draw(106, 38, box, V_HUDTRANS|V_PERPLAYER)
				v.drawString(162, 120, "Bomb:", fpp, "thin-center")
				v.drawString(162, 130, "TossFlag to throw", fpp, "thin-center")
			end
			if player.powitem == 1
				v.draw(143, 38, box, V_HUDTRANS|V_PERPLAYER)
				if player.tailsnapalm
					v.drawString(162, 120, "Napalm:", fpp, "thin-center")
					v.drawString(162, 130, "TossFlag to throw. Can break spikes", fpp, "thin-center")
				end
			end
			if player.powitem == 2
				v.draw(180, 38, box, V_HUDTRANS|V_PERPLAYER)
				if player.tailshelmet
					v.drawString(162, 120, "Helmet:", fpp, "thin-center")
					v.drawString(162, 130, "TossFlag to shield yourself", fpp, "thin-center")
				end
			end
			if player.powitem == 3
				v.draw(106, 74, box, V_HUDTRANS|V_PERPLAYER)
				if player.tailsrun
					v.drawString(162, 120, "Running Shoes:", fpp, "thin-center")
					v.drawString(162, 130, "Equip to accel and run faster", fpp, "thin-center")
				end
			end
			if player.powitem == 4
				v.draw(143, 74, box, V_HUDTRANS|V_PERPLAYER)
				if player.tailsrobot
					v.drawString(162, 120, "Robot:", fpp, "thin-center")
					v.drawString(162, 130, "TossFlag to send out. Spin to recall", fpp, "thin-center")
					v.drawString(162, 140, "Custom 3 to shoot a cork", fpp, "thin-center")
					v.drawString(162, 150, "If you encounter a scenario where you are slower than normal", fpp|V_YELLOWMAP, "thin-center")
					v.drawString(162, 160, "While controlling Tails, spawn another robot and recall it to fix!", fpp|V_YELLOWMAP, "thin-center")
				end
			end
			if player.powitem == 5
				v.draw(180, 74, box, V_HUDTRANS|V_PERPLAYER)
				if player.tailsraido
					v.drawString(162, 120, "Radio:", fpp, "thin-center")
					v.drawString(162, 130, "TossFlag play the selected song", fpp, "thin-center")
					v.drawString(162, 140, "Next/Prev Weapon to scroll", fpp, "thin-center")
				end
			end
			v.draw(108, 40, pow1, V_HUDTRANS|V_PERPLAYER)
			v.draw(145, 40, pow2, V_HUDTRANS|V_PERPLAYER)
			v.draw(182, 40, pow3, V_HUDTRANS|V_PERPLAYER)
			v.draw(108, 76, pow4, V_HUDTRANS|V_PERPLAYER)
			v.draw(145, 76, pow5, V_HUDTRANS|V_PERPLAYER)
			v.draw(182, 76, pow6, V_HUDTRANS|V_PERPLAYER)
		end
		v.drawString(-16, 155, "Current Powerup:", V_HUDTRANS|V_PERPLAYER, "small-thin-center")
		v.cachePatch(mlem)
		v.drawScaled(24*FRACUNIT, 162*FRACUNIT, FRACUNIT/2, v.getSpritePatch(mlem), V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	end
end, "game")

//Menu Activation
addHook("PlayerThink", function(p)
	local mo = p.mo
	local skin = "tatails"
	
	if (p.cmd.buttons & BT_CUSTOM3 and p.mo.skin == skin)
	and not p.tailsmenuing
	and not p.tailsroboting
	and P_IsObjectOnGround(mo)
		p.mo.state = S_TAILS_MENU
		p.tailsmenuing = true
		if p.sounding == 0
			S_StartSound(mo, sfx_kc63)
			p.sounding = 1
		end
	end
end)

//Menu Things
addHook("PreThinkFrame", do
	for player in players.iterate
		local mo = player.mo
		local p = player
		if not (mo or mo.valid)
		or mo.skin ~= "tatails"
		or p.bot == BOT_2PAI
			continue
		end
		
		if player.tailsmenuing
			player.pflags = $|PF_FULLSTASIS
		end
		
		if p.powitem == nil
			p.powitem = 0
		end
		
		//So the sound doesn't play every tic the menu is open
		if p.sounding == nil
			p.sounding = 0
		end
		
		//Right Button Check
		if p.cmd.sidemove < 25
			p.rightready = true
			p.righttapping = false
		elseif p.rightready
			p.righttapping = true
			p.rightready = false
		else
			p.righttapping = false
		end
	
		//Left Button Check
		if p.cmd.sidemove > -25
			p.leftready = true
			p.lefttapping = false
		elseif p.leftready
			p.lefttapping = true
			p.leftready = false
		else
			p.lefttapping = false
		end
		
		//Up Button Check
		if p.cmd.forwardmove < 25
			p.upready = true
			p.uptapping = false
		elseif p.upready
			p.uptapping = true
			p.upready = false
		else
			p.uptapping = false
		end
		
		//Down Button Check
		if p.cmd.forwardmove > -25
			p.downready = true
			p.downtapping = false
		elseif p.downready
			p.downtapping = true
			p.downready = false
		else
			p.downtapping = false
		end
		
		//Jump Press Check
		if not (p.cmd.buttons & BT_JUMP)
			p.selectready = true
			p.selecttapping = false
		elseif p.selectready
			p.selecttapping = true
			p.selectready = false
		else
			p.selecttapping = false
		end
		
		if p.tailsmenuing
			//Moving Left
			if p.lefttapping
				S_StartSound(nil, sfx_menu1, p)
				if p.powitem == 0
					p.powitem = 2
				elseif p.powitem == 1
					p.powitem = 0
				elseif p.powitem == 2
					p.powitem = 1
				elseif p.powitem == 3
					p.powitem = 5
				elseif p.powitem == 4
					p.powitem = 3
				elseif p.powitem == 5
					p.powitem = 4
				end
			end
			//Moving Right
			if p.righttapping
				S_StartSound(nil, sfx_menu1, p)
				if p.powitem == 0
					p.powitem = 1
				elseif p.powitem == 1
					p.powitem = 2
				elseif p.powitem == 2
					p.powitem = 0
				elseif p.powitem == 3
					p.powitem = 4
				elseif p.powitem == 4
					p.powitem = 5
				elseif p.powitem == 5
					p.powitem = 3
				end
			end
			//Moving Up
			if p.uptapping
				S_StartSound(nil, sfx_menu1, p)
				if p.powitem == 0
					p.powitem = 3
				elseif p.powitem == 3
					p.powitem = 0
				elseif p.powitem == 1
					p.powitem = 4
				elseif p.powitem == 4
					p.powitem = 1
				elseif p.powitem == 2
					p.powitem = 5
				elseif p.powitem == 5
					p.powitem = 2
				end
			end
			//Moving Down
			if p.downtapping
				S_StartSound(nil, sfx_menu1, p)
				if p.powitem == 0
					p.powitem = 3
				elseif p.powitem == 3
					p.powitem = 0
				elseif p.powitem == 1
					p.powitem = 4
				elseif p.powitem == 4
					p.powitem = 1
				elseif p.powitem == 2
					p.powitem = 5
				elseif p.powitem == 5
					p.powitem = 2
				end
			end
			//If you're in a scenario where the menu SHOULD close, then close it
			if (mo.state == S_PLAY_DEAD
			or mo.state == S_PLAY_DRWN
			or P_PlayerInPain(p)
			or p.powers[pw_carry]
			or mo.state == S_PLAY_ROLL
			or p.exiting)
				p.tailsmenuing = false
				p.sounding = 0
			end
			//Otherwise close it with buttons
			if p.selecttapping
				if p.powitem == 0
					p.tailsselect = 1
				elseif p.powitem == 1
					if not p.tailsnapalm
						S_StartSound(nil, sfx_lose, p)
						return false
					end
					p.tailsselect = 2
				elseif p.powitem == 2
					if not p.tailshelmet
						S_StartSound(nil, sfx_lose, p)
						return false
					end
					p.tailsselect = 3
				elseif p.powitem == 3
					if not p.tailsrun
						S_StartSound(nil, sfx_lose, p)
						return false
					end
					p.tailsselect = 4
				elseif p.powitem == 4
					if not p.tailsrobot
						S_StartSound(nil, sfx_lose, p)
						return false
					end
					p.tailsselect = 5
				elseif p.powitem == 5
					if not p.tailsraido
						S_StartSound(nil, sfx_lose, p)
						return false
					end
					p.tailsselect = 6
				end
				p.tailsmenuing = false
				mo.state = S_PLAY_STND
				p.sounding = 0
			end
			if p.cmd.buttons & BT_USE
				mo.state = S_PLAY_STND
				p.tailsmenuing = false
				p.sounding = 0
			end
		end
	end
end)
		

//You Spin Me Right Round Baby Right Round
addHook("PlayerThink",function(p)
	local mo = p.mo
	local skin = "tatails"
	
	-- Default to "not spinning"
	if p.tailspin == nil
		p.tailspin = false
	end
	
	if not ((mo and mo.valid) and mo.health) then return end
    if (mo.skin != skin) then return end

	if (p.cmd.buttons & BT_CUSTOM2 
	and not p.tailspin 
	and not p.upside 
	and mo.state ~=S_UPSIDE 
	and mo.state ~= S_PLAY_FLY 
	and mo.state ~= S_PLAY_JUMP
	and mo.state ~= S_PLAY_FALL
	and p.speed == 0 
	and not p.tailsroboting)
		mo.state = S_TAILSPIN
		p.tailspin = true
		if S_MusicName(p) ~= "TSPIN"
            S_ChangeMusic("TSPIN", true, p)
		end
	end
	if p.tailspin     
        if p.speed ~= 0 or mo.state ~= S_TAILSPIN
			mo.state = S_PLAY_STND
            p.tailspin = false
			if S_MusicName(p) == "TSPIN"
				P_RestoreMusic(p)
			end
        end
		if not P_IsObjectOnGround(mo)
			p.tailspin = false
			mo.state = S_PLAY_JUMP
			if S_MusicName(p) == "TSPIN"
				P_RestoreMusic(p)
			end
		end
    end
end)

//Flight Time
addHook("PlayerThink",function(player)
	local mo = player.mo
	local skin = "tatails"
	local flighttime = 1
	
	if not mo
	or mo.skin ~= skin
		return 
	end

	if player.isflying and player.onground
		player.isflying = false
		player.onground = false

		-- For every emerald collected, gain 2 extra seconds of flight
		for i, em in ipairs({EMERALD1, EMERALD2, EMERALD3, EMERALD4, EMERALD5, EMERALD6, EMERALD7}) do
			if emeralds & em then flighttime = i * 2 end
			player.powers[pw_tailsfly] = flighttime*TICRATE
		end
		-- If you're super, you have "infinite" flight
		if player.powers[pw_super]
			player.powers[pw_tailsfly] = 999*TICRATE
		end
	end
	
	if player.powers[pw_tailsfly] == 0
	and (P_IsObjectOnGround(mo) or player.powers[pw_carry] or mo.state == S_PLAY_RIDE or mo.state == S_PLAY_FLY_TIRED)
	or not (P_IsObjectOnGround and mo.state == S_PLAY_FLY)
		player.onground = true
	end
end)

//Adjust Flight Time
addHook("AbilitySpecial", function(player)
	local mo = player.mo
	local skin = "tatails"
	
	if not mo
	or mo.skin ~= skin
	or player.charability ~= CA_FLY
	or player.pflags & PF_THOKKED
		return
	end
	
	player.isflying = true
end)

//Flight Cancel by Sonic12 (Open Assets)
addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "tatails")
			if not (player.mo.usedown) then
				player.mo.usedown = 0
			end
	   
			if not (player.mo.flydrop) then
				player.mo.flydrop = 0
			end
	  
			if (player.cmd.buttons & BT_CUSTOM1)
			and (player.mo.usedown == 0)
			and not P_IsObjectOnGround(player.mo)
			and player.mo.state ~= S_PLAY_JUMP
			and player.mo.state ~= S_PLAY_FALL
			and player.mo.state ~= S_PLAY_SPRING
			and not P_PlayerInPain(player)
			and player.mo.state ~= S_PLAY_FLY_TIRED
				player.mo.usedown = 1
				player.mo.flydrop = 1
				player.mo.state = S_PLAY_FALL
				player.pflags = $1|PF_JUMPED
			end
			if not (player.cmd.buttons & BT_CUSTOM1)
			and (player.mo.usedown == 1)
				player.mo.usedown = 0
			end
		end
	end
end)

//Don't Think Shields Will Let You Attack Them Either
addHook("SpinSpecial", function (player)
	if not player.mo
	or player.mo.skin ~= "tatails"
	or not player.mo.health
	or player.exiting
	or not player.realtime
	or player.pflags & PF_STARTDASH
	or player.powers[pw_carry] == CR_NIGHTSMODE
		return
	end
	
	local mo = player.mo
	local shield = player.powers[pw_shield] & ~SH_FIREFLOWER
	if shield == SH_THUNDERCOIN -- If you have the lightning shield
	or shield == SH_FLAMEAURA -- Or if you have a fire shield
	or shield == SH_ATTRACT -- Or if you have a magnet shield
		if (mo.state == S_PLAY_FLY -- And you're not flying
		or mo.state == S_PLAY_FLY_TIRED -- Or tired of flying
		or mo.state == S_PLAY_SPRING -- ....or in the spring animation
		or mo.state == S_PLAY_RIDE -- Or being caried by something...
		or mo.state == S_PLAY_FALL -- Or if you're not already falling
		or P_PlayerInPain(player) -- ...or in pain
		or P_IsObjectOnGround(mo)) -- or you're on the ground
			return
		end
		mo.state = S_PLAY_FALL
	end
end)

addHook("PlayerCanDamage", function(player, mobj)
	if player.mo and player.mo.skin == "tatails"
	and player.mo.state == S_PLAY_FALL
	and (mobj.flags&MF_ENEMY or mobj.flags&MF_BOSS or mobj.flags&MF_MONITOR) return false end
end, MT_PLAYER)

//Bomb Throw
addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "tatails"
		and not player.tailsroboting
			
			-- bomb cooldown so you can't just spam it
			if player.bombcooldown == nil
				player.bombcooldown = 0
			-- deplete timer
			elseif player.bombcooldown > 0
				player.bombcooldown = $-1
			end
			
			if not (player.mo.fire)
				player.mo.fire = 0
			end
			
			if not (player.powers[pw_carry] == CR_NIGHTSMODE) 
			and not (player.powers[pw_carry]) 
			and not (player.pflags & PF_STASIS) 
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT) 
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.state == S_PLAY_SUPER_TRANS2)
			and not (player.mo.state == S_PLAY_SUPER_TRANS3)
			and not (player.mo.state == S_PLAY_SUPER_TRANS4)
			and not (player.mo.state == S_PLAY_SUPER_TRANS5)
			and not (player.mo.state == S_PLAY_SUPER_TRANS6)
			and not player.exiting
			and P_PlayerInPain(player) == false
		    and player.playerstate == PST_LIVE
			and (player.cmd.buttons & BT_TOSSFLAG)
			and player.mo.fire == 0
			and player.bombcooldown == 0
			and player.mo.state ~= S_PLAY_ROLL
			and player.mo.state ~= S_PLAY_SPINDASH
			and player.tailsselect == 1
			and not player.tailsmenuing
				player.mo.fire = 1
				player.bombcooldown = 70
				if P_IsObjectOnGround(player.mo) and not player.speed
					player.mo.state = S_BTHROW
				end
				local flame = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
			end
			if not (player.powers[pw_carry] == CR_NIGHTSMODE) 
			and not (player.powers[pw_carry]) 
			and not (player.pflags & PF_STASIS) 
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT) 
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.state == S_PLAY_SUPER_TRANS2)
			and not (player.mo.state == S_PLAY_SUPER_TRANS3)
			and not (player.mo.state == S_PLAY_SUPER_TRANS4)
			and not (player.mo.state == S_PLAY_SUPER_TRANS5)
			and not (player.mo.state == S_PLAY_SUPER_TRANS6)
			and not player.exiting
			and P_PlayerInPain(player) == false
		    and player.playerstate == PST_LIVE
			and (player.cmd.buttons & BT_TOSSFLAG)
			and player.mo.fire == 0
			and player.bombcooldown == 0
			and player.mo.state ~= S_PLAY_ROLL
			and player.mo.state ~= S_PLAY_SPINDASH
			and player.tailsnapalm
			and player.tailsselect == 2
			and not player.tailsmenuing
				player.mo.fire = 1
				player.bombcooldown = 105
				if P_IsObjectOnGround(player.mo) and not player.speed
					player.mo.state = S_BTHROW
				end
				local flamen = P_SpawnPlayerMissile(player.mo, MT_NAPALMPRO)
			end
			if not (player.cmd.buttons & BT_TOSSFLAG)
				player.mo.fire = 0
			end
		end
	end
end)

addHook("MobjThinker", function(flame)
	-- Defines the player
	for player in players.iterate do
		-- Gravity Flip
		if (player.mo.eflags & MFE_VERTICALFLIP)
			flame.eflags = $1|MFE_VERTICALFLIP -- Considers it flipped
			flame.flags2 = $1|MF2_OBJECTFLIP -- Visually flips it upside down
		end
		-- Floor breaking
		if P_IsObjectOnGround(flame) // If the flame is on the ground...
			for x = flame.x, flame.x + flame.radius, flame.radius -- The following will set up variables for floor breaking
				for y = flame.y, flame.y + flame.radius, flame.radius
					local ss = R_PointInSubsector(x,y)
					for fof in ss.sector.ffloors()
						if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS) // If a breakable floor exists where the flame lands...
							EV_CrumbleChain(ss.sector, fof) -- Breaks that floor
						end
					end
				end
			end
		end
	end
end, MT_FBOMB)

//What Is A Wall????
local wallbreak = function(mobj, sectorthing)
	for fof in sectorthing.ffloors()
		if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
			local foffloor = fof.topheight
			local fofceiling = fof.bottomheight
			if fof.b_slope and fof.b_slope.valid
				fofceiling = P_GetZAt(fof.b_slope, mobj.x, mobj.y)
			end
			if fof.t_slope and fof.t_slope.valid
				foffloor = P_GetZAt(fof.t_slope, mobj.x, mobj.y)
			end
			if foffloor >= mobj.z and fofceiling <= mobj.z+mobj.height
				EV_CrumbleChain(nil, fof)
				if fof.master.flags & ML_EFFECT5
					P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mobj, sectorthing)
				end
				return true
			end
		end
	end
end

//Break The Wall
addHook("MobjLineCollide", function(mobj, line)
	local mlem -- Because :3
	local mlem2 -- Because I'm so :3
	
	if not (line and line.valid and mobj and mobj.valid)
		return
	end
	
	if line.frontsector
	and line.frontsector.valid
		mlem = wallbreak(mobj,line.frontsector)
	end
	
	if line.backsector
	and line.backsector.valid
		mlem2 = wallbreak(mobj, line.backsector)
	end
	
	if mlem
	or mlem2
		P_ExplodeMissile(mobj)
	end
end, MT_FBOMB)

//Victory Pose
addHook("PlayerThink", function(p)
	local mo = p.mo
	
	if not mo
	or mo.skin ~= "tatails"
		return
	end
	
	if p.exiting
	and p.speed == 0
	and P_IsObjectOnGround(mo)
	and (mo.state == S_PLAY_STND or mo.state == S_PLAY_WAIT)
		mo.state = S_TVICTORY1
	end
end)

//Helmet (Code taken from "OpenCharacterAssets")
// CUSTOMIZE SECTION START
local skin = "tatails" // your character here
local thebutton = BT_TOSSFLAG // the button needed to do the parry
local sound = sfx_s3k8c // the sound of the parry
local sound2 = 	sfx_bnce1 // blocking sound
local parryframes = 70 // frames of the parry
local parrydelay = 350 // the delay of parrying
local thrustspeed = 5 // how far enemies are thrusted
local cooldownhud = true // if this is true, the cooldown will be shown in a heads up display
// CUSTOMIZE SECTION END PROCCED BELOW IF YOU KNOW WHAT YOUR DOING

freeslot("MT_PARRYSHIELD")

mobjinfo[MT_PARRYSHIELD] =
{
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_HELM,
	deathstate = S_HELM,
	xdeathstate = S_HELM,
	radius = 42*FRACUNIT,
	height = 60*FRACUNIT,
	flags = MF_NOGRAVITY
}

hud.add(function(v,player)
	if player.mo and player.mo.skin == skin and player.weapondelay and cooldownhud == true
		local xpos = hudinfo[HUD_LIVES].x
		local ypos = hudinfo[HUD_LIVES].y
		v.drawString(xpos, (ypos - 39), ("COOLDOWN:" + (player.weapondelay)), V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.parrying == nil
		player.mo.parrying = false
	end
	if player.mo.parrytime == nil
		player.mo.parrytime = 0
	end
	if player.mo.parrytime > 0
		player.pflags = $|PF_FULLSTASIS
		player.mo.parrytime = $ - 1
		local shield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_PARRYSHIELD)
		shield.target = player.mo
		shield.scale = player.mo.scale*0
		shield.frame = $ |FF_TRANS50
	end
	if player.mo.parrytime == 1
		player.mo.parrytime = 0
		player.mo.parrying = false
		player.pflags = $1 & ~PF_FULLSTASIS
		player.weapondelay = parrydelay
		player.mo.state = S_PLAY_STND
	end
	if player.mo and player.mo.skin == skin and player.tailshelmet and player.tailsselect == 3
	and (player.cmd.buttons & thebutton)
	and player.mo.parrying == false
	and player.mo.parrytime == 0
	and not player.weapondelay
	and P_IsObjectOnGround(player.mo)
		S_StartSound(player.mo, sound)
		player.mo.parrytime = parryframes
		player.mo.state = S_HELM
	end
end)

addHook("MobjThinker", function(shield)
	if (shield.target and shield.target.valid) and (shield.target.parrytime == 0)
		P_RemoveMobj(shield)
	end
end, MT_PARRYSHIELD)

addHook("MobjCollide", function(shield, other)
	if (other.z > shield.z+shield.height) or (shield.z > other.z+other.height) return end
	if (other and other.valid) and (other.flags & MF_ENEMY)
	and shield.parrytime > 0 
		P_InstaThrust(other,shield.angle,FRACUNIT*thrustspeed*2)
		P_SetObjectMomZ(other, 5*FRACUNIT, false)
		S_StartSound(shield, sound2)
		other.target = shield
		other.flags = $&~MF_SPECIAL
		other.flags = $ |MF_GRENADEBOUNCE|MF_MISSILE
	end
	if (other and other.valid) and (other.flags & MF_BOSS)
	and shield.parrytime > 0 
		P_InstaThrust(other,shield.angle,FRACUNIT*thrustspeed)
		P_DamageMobj(other, shield, shield)
		S_StartSound(shield, sound2)
	end
end, MT_PLAYER)

//Tails pipebombs and speeens the chat
addHook("PlayerMsg", function(p, msgtype, target, msg)
    if (msgtype) then return end
    
    local mo = p.mo
    if not ((mo and mo.valid) and mo.health) then return end
    if (mo.skin !="tatails") then return end
    if (mo.state != S_PLAY_STND and mo.state != S_PLAY_WAIT) then return end
    if (mo.tpipebomb) then return end
    if (p.speed) then return end
    if not (P_IsObjectOnGround(mo)) then return end
        
    -- What you typin?
    msg = $:lower()
    if (msg == "pipebomb" and not mo.tpipebomb)
        p.panim = PA_IDLE
        mo.state = S_TPIPE
        mo.tpipebomb = true
		if S_MusicName(p) ~= "PIPEB" then
            S_ChangeMusic("PIPEB", true, p)
		end
    end
	if (msg == "speeen" and not mo.upside)
		p.panim = PA_IDLE
		mo.state = S_UPSIDE
		mo.upside = true
		if S_MusicName(p) ~= "TUPS"
			S_ChangeMusic("TUPS", true, p)
		end
	end
end)

//Tails pipebombs and speeens the game
addHook("PlayerThink",function(p)
    if not (p.mo and p.mo.valid) then return end
    local mo = p.mo
		
    if mo.tpipebomb then        
        if p.speed ~= 0 or mo.state ~= S_TPIPE then
			mo.state = S_PLAY_STND
            mo.tpipebomb = false
            if S_MusicName(p) == "PIPEB" then
                P_RestoreMusic(p)
            end
        end
		if not P_IsObjectOnGround(mo)
			mo.state = S_PLAY_JUMP
			mo.tpipebomb = false
			if S_MusicName(p) == "PIPEB" then
                P_RestoreMusic(p)
            end
		end
    end
	
	if mo.upside
		if p.speed ~= 0 or mo.state ~= S_UPSIDE
			mo.state = S_PLAY_STND
			mo.upside = false
			if S_MusicName(p) == "TUPS"
				P_RestoreMusic(p)
			end
		end
		if not P_IsObjectOnGround(mo)
			mo.state = S_PLAY_JUMP
			mo.upside = false
			if S_MusicName(p) == "TUPS" then
                P_RestoreMusic(p)
            end
		end
	end
end)

//Tails Waiting Controls
/*addHook("PlayerThink", function(player)
	local mo = player.mo
	local skin = "tatails"
	
	if not (mo or mo.valid)
	and mo.skin ~= skin
		return
	end
	
	if mo.state == S_PLAY_WAIT
		if mo.state == S_TAILS_WAIT2
			return
		end
		mo.state = S_TAILS_WAIT
	end
end)*/
	

//Tails CD Bot Stuff
addHook("PreThinkFrame", do
	//Don't do this if you're on multiplayer/netgames dummy
	if netgame or multiplayer
		return
	end
	
	//I'm only realising after the fact that I could have saved a lot of trouble by creating variables...
	
	local ahh = 0
	
	if players[0] -- If player 1 exists
	and players[0].mo.skin == "cdsonic" -- And player 1 is controlling CDSonic (since idk how to swap yet)
		if players[0].powers[pw_super] -- And if player 1 is super
			if players[0].mo.state == S_PLAY_SUPER_TRANS1 -- And entering your transformation state
			and players[1].mo.state ~= S_PLAY_SUPER_TRANS1 -- But player 2 isn't
				players[1].mo.state = S_PLAY_SUPER_TRANS1 -- Make player 2 enter their transformation state
			end
			players[1].charflags = $ | SF_SUPER -- Make player 2 ACTUALLY super
			players[1].powers[pw_super] = players[0].powers[pw_super] -- Make the duration last as long as yours
			players[1].rings = players[0].rings -- If they have more/less rings, no they don't
		end
	end
end)
